org.eclipse.viatra.cep.core.engine.compiler

## Class EpsilonTransitionMatcher

- java.lang.Object
- - org.eclipse.viatra.query.runtime.internal.apiimpl.QueryResultWrapper
  - - org.eclipse.viatra.query.runtime.api.impl.BaseMatcher<EpsilonTransitionMatch>
    - - org.eclipse.viatra.cep.core.engine.compiler.EpsilonTransitionMatcher

- All Implemented Interfaces:
    ViatraQueryMatcher<EpsilonTransitionMatch>

      public class EpsilonTransitionMatcher
      extends BaseMatcher<EpsilonTransitionMatch>

  Generated pattern matcher API of the org.eclipse.viatra.cep.core.engine.compiler.epsilonTransition pattern, providing pattern-specific query methods.

  Use the pattern matcher on a given model via `on(ViatraQueryEngine)`, e.g. in conjunction with `ViatraQueryEngine#on(Notifier)`.

  Matches of the pattern will be represented as `EpsilonTransitionMatch`.

  Original source: ``

       pattern
       epsilonTransition(automaton : Automaton, transition : EpsilonTransition, preState : State, postState : State) {
              Automaton.states(automaton, preState);
              Automaton.states(automaton, postState);
              State.outTransitions(preState, transition);
              State.inTransitions(postState, transition);
       }

  See Also:
    `EpsilonTransitionMatch`, `EpsilonTransitionProcessor`, `EpsilonTransitionQuerySpecification`

- - ### Field Summary

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.api.impl.BaseMatcher

      `engine, querySpecification`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.internal.apiimpl.QueryResultWrapper

      `backend`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected EpsilonTransitionMatch` | `arrayToMatch(java.lang.Object[] match)` Converts the array representation of a pattern match to an immutable Match object.
    `protected EpsilonTransitionMatch` | `arrayToMatchMutable(java.lang.Object[] match)` Converts the array representation of a pattern match to a mutable Match object.
    `int` | `countMatches(Automaton pAutomaton, EpsilonTransition pTransition, State pPreState, State pPostState)` Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
    `static EpsilonTransitionMatcher` | `create()`
    `void` | `forEachMatch(Automaton pAutomaton, EpsilonTransition pTransition, State pPreState, State pPostState, IMatchProcessor<? super EpsilonTransitionMatch> processor)` Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
    `boolean` | `forOneArbitraryMatch(Automaton pAutomaton, EpsilonTransition pTransition, State pPreState, State pPostState, IMatchProcessor<? super EpsilonTransitionMatch> processor)` Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
    `java.util.Collection<EpsilonTransitionMatch>` | `getAllMatches(Automaton pAutomaton, EpsilonTransition pTransition, State pPreState, State pPostState)` Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
    `java.util.Set<Automaton>` | `getAllValuesOfautomaton()` Retrieve the set of values that occur in matches for automaton.
    `java.util.Set<Automaton>` | `getAllValuesOfautomaton(EpsilonTransitionMatch partialMatch)` Retrieve the set of values that occur in matches for automaton.
    `java.util.Set<Automaton>` | `getAllValuesOfautomaton(EpsilonTransition pTransition, State pPreState, State pPostState)` Retrieve the set of values that occur in matches for automaton.
    `java.util.Set<State>` | `getAllValuesOfpostState()` Retrieve the set of values that occur in matches for postState.
    `java.util.Set<State>` | `getAllValuesOfpostState(Automaton pAutomaton, EpsilonTransition pTransition, State pPreState)` Retrieve the set of values that occur in matches for postState.
    `java.util.Set<State>` | `getAllValuesOfpostState(EpsilonTransitionMatch partialMatch)` Retrieve the set of values that occur in matches for postState.
    `java.util.Set<State>` | `getAllValuesOfpreState()` Retrieve the set of values that occur in matches for preState.
    `java.util.Set<State>` | `getAllValuesOfpreState(Automaton pAutomaton, EpsilonTransition pTransition, State pPostState)` Retrieve the set of values that occur in matches for preState.
    `java.util.Set<State>` | `getAllValuesOfpreState(EpsilonTransitionMatch partialMatch)` Retrieve the set of values that occur in matches for preState.
    `java.util.Set<EpsilonTransition>` | `getAllValuesOftransition()` Retrieve the set of values that occur in matches for transition.
    `java.util.Set<EpsilonTransition>` | `getAllValuesOftransition(Automaton pAutomaton, State pPreState, State pPostState)` Retrieve the set of values that occur in matches for transition.
    `java.util.Set<EpsilonTransition>` | `getAllValuesOftransition(EpsilonTransitionMatch partialMatch)` Retrieve the set of values that occur in matches for transition.
    `EpsilonTransitionMatch` | `getOneArbitraryMatch(Automaton pAutomaton, EpsilonTransition pTransition, State pPreState, State pPostState)` Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
    `boolean` | `hasMatch(Automaton pAutomaton, EpsilonTransition pTransition, State pPreState, State pPostState)` Indicates whether the given combination of specified pattern parameters constitute a valid pattern match, under any possible substitution of the unspecified parameters (if any).
    `EpsilonTransitionMatch` | `newMatch(Automaton pAutomaton, EpsilonTransition pTransition, State pPreState, State pPostState)` Returns a new (partial) match.
    `static EpsilonTransitionMatcher` | `on(ViatraQueryEngine engine)` Initializes the pattern matcher within an existing VIATRA Query engine.
    `static IQuerySpecification<EpsilonTransitionMatcher>` | `querySpecification()`
    `protected java.util.Set<Automaton>` | `rawAccumulateAllValuesOfautomaton(java.lang.Object[] parameters)` Retrieve the set of values that occur in matches for automaton.
    `protected java.util.Set<State>` | `rawAccumulateAllValuesOfpostState(java.lang.Object[] parameters)` Retrieve the set of values that occur in matches for postState.
    `protected java.util.Set<State>` | `rawAccumulateAllValuesOfpreState(java.lang.Object[] parameters)` Retrieve the set of values that occur in matches for preState.
    `protected java.util.Set<EpsilonTransition>` | `rawAccumulateAllValuesOftransition(java.lang.Object[] parameters)` Retrieve the set of values that occur in matches for transition.
    `protected EpsilonTransitionMatch` | `tupleToMatch(Tuple t)`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.api.impl.BaseMatcher

      `countMatches, countMatches, emptyArray, forEachMatch, forEachMatch, forOneArbitraryMatch, forOneArbitraryMatch, getAllMatches, getAllMatches, getAllValues, getAllValues, getCapabilities, getEngine, getOneArbitraryMatch, getOneArbitraryMatch, getParameterNames, getPatternName, getPositionOfParameter, getSpecification, hasMatch, matchToArray, newEmptyMatch, newMatch, rawAccumulateAllValues, rawCountMatches, rawForEachMatch, rawForOneArbitraryMatch, rawGetAllMatches, rawGetAllValues, rawGetOneArbitraryMatch, rawHasMatch, setBackend`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### on

          public static EpsilonTransitionMatcher on(ViatraQueryEngine engine)
                                             throws ViatraQueryException

      Initializes the pattern matcher within an existing VIATRA Query engine. If the pattern matcher is already constructed in the engine, only a light-weight reference is returned. The match set will be incrementally refreshed upon updates.
      Parameters:
        `engine` - the existing VIATRA Query engine in which this matcher will be created.
      Throws:
        `ViatraQueryException` - if an error occurs during pattern matcher creation

    - #### create

          public static EpsilonTransitionMatcher create()
                                                 throws ViatraQueryException

      Returns:
        an initialized matcher
      Throws:
        `ViatraQueryException` - if an error occurs during pattern matcher creation
      No Reference:
        This method is for internal matcher initialization by the framework, do not call it manually.

    - #### getAllMatches

          public java.util.Collection<EpsilonTransitionMatch> getAllMatches(Automaton pAutomaton,
                                                                            EpsilonTransition pTransition,
                                                                            State pPreState,
                                                                            State pPostState)

      Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
      Parameters:
        `pAutomaton` - the fixed value of pattern parameter automaton, or null if not bound.
        `pTransition` - the fixed value of pattern parameter transition, or null if not bound.
        `pPreState` - the fixed value of pattern parameter preState, or null if not bound.
        `pPostState` - the fixed value of pattern parameter postState, or null if not bound.
      Returns:
        matches represented as a EpsilonTransitionMatch object.

    - #### getOneArbitraryMatch

          public EpsilonTransitionMatch getOneArbitraryMatch(Automaton pAutomaton,
                                                             EpsilonTransition pTransition,
                                                             State pPreState,
                                                             State pPostState)

      Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters. Neither determinism nor randomness of selection is guaranteed.
      Parameters:
        `pAutomaton` - the fixed value of pattern parameter automaton, or null if not bound.
        `pTransition` - the fixed value of pattern parameter transition, or null if not bound.
        `pPreState` - the fixed value of pattern parameter preState, or null if not bound.
        `pPostState` - the fixed value of pattern parameter postState, or null if not bound.
      Returns:
        a match represented as a EpsilonTransitionMatch object, or null if no match is found.

    - #### hasMatch

          public boolean hasMatch(Automaton pAutomaton,
                                  EpsilonTransition pTransition,
                                  State pPreState,
                                  State pPostState)

      Indicates whether the given combination of specified pattern parameters constitute a valid pattern match, under any possible substitution of the unspecified parameters (if any).
      Parameters:
        `pAutomaton` - the fixed value of pattern parameter automaton, or null if not bound.
        `pTransition` - the fixed value of pattern parameter transition, or null if not bound.
        `pPreState` - the fixed value of pattern parameter preState, or null if not bound.
        `pPostState` - the fixed value of pattern parameter postState, or null if not bound.
      Returns:
        true if the input is a valid (partial) match of the pattern.

    - #### countMatches

          public int countMatches(Automaton pAutomaton,
                                  EpsilonTransition pTransition,
                                  State pPreState,
                                  State pPostState)

      Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
      Parameters:
        `pAutomaton` - the fixed value of pattern parameter automaton, or null if not bound.
        `pTransition` - the fixed value of pattern parameter transition, or null if not bound.
        `pPreState` - the fixed value of pattern parameter preState, or null if not bound.
        `pPostState` - the fixed value of pattern parameter postState, or null if not bound.
      Returns:
        the number of pattern matches found.

    - #### forEachMatch

          public void forEachMatch(Automaton pAutomaton,
                                   EpsilonTransition pTransition,
                                   State pPreState,
                                   State pPostState,
                                   IMatchProcessor<? super EpsilonTransitionMatch> processor)

      Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
      Parameters:
        `pAutomaton` - the fixed value of pattern parameter automaton, or null if not bound.
        `pTransition` - the fixed value of pattern parameter transition, or null if not bound.
        `pPreState` - the fixed value of pattern parameter preState, or null if not bound.
        `pPostState` - the fixed value of pattern parameter postState, or null if not bound.
        `processor` - the action that will process each pattern match.

    - #### forOneArbitraryMatch

          public boolean forOneArbitraryMatch(Automaton pAutomaton,
                                              EpsilonTransition pTransition,
                                              State pPreState,
                                              State pPostState,
                                              IMatchProcessor<? super EpsilonTransitionMatch> processor)

      Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters. Neither determinism nor randomness of selection is guaranteed.
      Parameters:
        `pAutomaton` - the fixed value of pattern parameter automaton, or null if not bound.
        `pTransition` - the fixed value of pattern parameter transition, or null if not bound.
        `pPreState` - the fixed value of pattern parameter preState, or null if not bound.
        `pPostState` - the fixed value of pattern parameter postState, or null if not bound.
        `processor` - the action that will process the selected match.
      Returns:
        true if the pattern has at least one match with the given parameter values, false if the processor was not invoked

    - #### newMatch

          public EpsilonTransitionMatch newMatch(Automaton pAutomaton,
                                                 EpsilonTransition pTransition,
                                                 State pPreState,
                                                 State pPostState)

      Returns a new (partial) match. This can be used e.g. to call the matcher with a partial match.

      The returned match will be immutable. Use `BaseMatcher.newEmptyMatch()` to obtain a mutable match object.

      Parameters:
        `pAutomaton` - the fixed value of pattern parameter automaton, or null if not bound.
        `pTransition` - the fixed value of pattern parameter transition, or null if not bound.
        `pPreState` - the fixed value of pattern parameter preState, or null if not bound.
        `pPostState` - the fixed value of pattern parameter postState, or null if not bound.
      Returns:
        the (partial) match object.

    - #### rawAccumulateAllValuesOfautomaton

          protected java.util.Set<Automaton> rawAccumulateAllValuesOfautomaton(java.lang.Object[] parameters)

      Retrieve the set of values that occur in matches for automaton.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfautomaton

          public java.util.Set<Automaton> getAllValuesOfautomaton()

      Retrieve the set of values that occur in matches for automaton.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfautomaton

          public java.util.Set<Automaton> getAllValuesOfautomaton(EpsilonTransitionMatch partialMatch)

      Retrieve the set of values that occur in matches for automaton.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfautomaton

          public java.util.Set<Automaton> getAllValuesOfautomaton(EpsilonTransition pTransition,
                                                                  State pPreState,
                                                                  State pPostState)

      Retrieve the set of values that occur in matches for automaton.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### rawAccumulateAllValuesOftransition

          protected java.util.Set<EpsilonTransition> rawAccumulateAllValuesOftransition(java.lang.Object[] parameters)

      Retrieve the set of values that occur in matches for transition.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOftransition

          public java.util.Set<EpsilonTransition> getAllValuesOftransition()

      Retrieve the set of values that occur in matches for transition.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOftransition

          public java.util.Set<EpsilonTransition> getAllValuesOftransition(EpsilonTransitionMatch partialMatch)

      Retrieve the set of values that occur in matches for transition.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOftransition

          public java.util.Set<EpsilonTransition> getAllValuesOftransition(Automaton pAutomaton,
                                                                           State pPreState,
                                                                           State pPostState)

      Retrieve the set of values that occur in matches for transition.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### rawAccumulateAllValuesOfpreState

          protected java.util.Set<State> rawAccumulateAllValuesOfpreState(java.lang.Object[] parameters)

      Retrieve the set of values that occur in matches for preState.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfpreState

          public java.util.Set<State> getAllValuesOfpreState()

      Retrieve the set of values that occur in matches for preState.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfpreState

          public java.util.Set<State> getAllValuesOfpreState(EpsilonTransitionMatch partialMatch)

      Retrieve the set of values that occur in matches for preState.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfpreState

          public java.util.Set<State> getAllValuesOfpreState(Automaton pAutomaton,
                                                             EpsilonTransition pTransition,
                                                             State pPostState)

      Retrieve the set of values that occur in matches for preState.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### rawAccumulateAllValuesOfpostState

          protected java.util.Set<State> rawAccumulateAllValuesOfpostState(java.lang.Object[] parameters)

      Retrieve the set of values that occur in matches for postState.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfpostState

          public java.util.Set<State> getAllValuesOfpostState()

      Retrieve the set of values that occur in matches for postState.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfpostState

          public java.util.Set<State> getAllValuesOfpostState(EpsilonTransitionMatch partialMatch)

      Retrieve the set of values that occur in matches for postState.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfpostState

          public java.util.Set<State> getAllValuesOfpostState(Automaton pAutomaton,
                                                              EpsilonTransition pTransition,
                                                              State pPreState)

      Retrieve the set of values that occur in matches for postState.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### tupleToMatch

          protected EpsilonTransitionMatch tupleToMatch(Tuple t)

      Specified by:
        `tupleToMatch` in class `BaseMatcher<EpsilonTransitionMatch>`

    - #### arrayToMatch

          protected EpsilonTransitionMatch arrayToMatch(java.lang.Object[] match)

      Description copied from class: `BaseMatcher`
      Converts the array representation of a pattern match to an immutable Match object.
      Specified by:
        `arrayToMatch` in class `BaseMatcher<EpsilonTransitionMatch>`

    - #### arrayToMatchMutable

          protected EpsilonTransitionMatch arrayToMatchMutable(java.lang.Object[] match)

      Description copied from class: `BaseMatcher`
      Converts the array representation of a pattern match to a mutable Match object.
      Specified by:
        `arrayToMatchMutable` in class `BaseMatcher<EpsilonTransitionMatch>`

    - #### querySpecification

          public static IQuerySpecification<EpsilonTransitionMatcher> querySpecification()
                                                                                  throws ViatraQueryException

      Returns:
        the singleton instance of the query specification of this pattern
      Throws:
        `ViatraQueryException` - if the pattern definition could not be loaded